{
QUARTERS VERSION 3.2
Copyright (C) 1987 by Greg Bailey
July 23, 1987
}

program quarters (input,output,kbd);

const
   value_head_penny   =   1;
   value_head_nickel  =   2;
   value_head_dime    =   3;
   value_head_quarter =  99;
   value_tail_penny   =  -1;
   value_tail_nickel  =  -2;
   value_tail_dime    =  -3;
   value_tail_quarter = -49;
   horizontal_bar     = 205;
   vertical_bar       = 186;
   upper_left         = 201;
   upper_right        = 187;
   lower_left         = 200;
   lower_right        = 188;
   left_t_bar         = 185;
   right_t_bar        = 204;
   top_t_bar          = 202;
   bottom_t_bar       = 203;
   block              = 220;
   preset_level       =   1;

type
   board_type = array [1..7,1..7] of integer;
   move_type  = array [1..4] of integer;

var
   board              : board_type;
   end_game           : boolean;
   level              : integer;
   human_last_move,
   computer_last_move : move_type;

{----------}

procedure initialize (var board:board_type; var end_game:boolean;
   var level:integer; var human_last_move,computer_last_move:move_type);

var
   temp1,
   temp2 : integer;

procedure draw_outer_row (y:integer);

var
   temp1,
   temp2 : integer;

begin
   gotoxy (5,y);
   for temp1 := 1 to 3 do
      begin
         write (chr(upper_left),chr(horizontal_bar),chr(top_t_bar));
         write (chr(horizontal_bar),chr(upper_right),' ':7);
      end;
   write (chr(upper_left),chr(horizontal_bar),chr(top_t_bar));
   write (chr(horizontal_bar),chr(upper_right));
   gotoxy (5,(y+1));
   for temp1 := 1 to 3 do
      begin
         write (chr(left_t_bar),' ':3,chr(right_t_bar));
         for temp2 := 1 to 7 do write (chr(horizontal_bar));
      end;
   write (chr(left_t_bar),' ':3,chr(right_t_bar));
   gotoxy (5,(y+2));
   write (chr(lower_left),chr(horizontal_bar),chr(bottom_t_bar));
   write (chr(horizontal_bar),chr(lower_right));
   for temp1 := 1 to 3 do
      begin
         write (chr(block),' ':5,chr(block),chr(lower_left));
         write (chr(horizontal_bar),chr(bottom_t_bar));
         write (chr(horizontal_bar),chr(lower_right));
      end;
end;

procedure draw_inner_row (y:integer);

var
   temp1,
   temp2 : integer;

begin
   gotoxy (7,y);
   for temp1 := 1 to 3 do
      begin
         write (chr(vertical_bar),' ':3,chr(upper_left));
         for temp2 := 1 to 3 do write (chr(horizontal_bar));
         write (chr(upper_right),' ':3);
      end;
   write (chr(vertical_bar));
   gotoxy (7,(y+1));
   for temp1 := 1 to 9 do write (chr(vertical_bar),' ':3);
   write (chr(vertical_bar));
   gotoxy (7,(y+2));
   for temp1 := 1 to 3 do
      begin
         write (chr(vertical_bar),' ':2,chr(block),chr(lower_left));
         for temp2 := 1 to 3 do write (chr(horizontal_bar));
         write (chr(lower_right),chr(block),' ':2);
      end;
   write (chr(vertical_bar));
end;

begin
   textcolor (lightgray);
   clrscr;
   for temp1 := 1 to 9 do writeln;
   write (' ':17,chr(upper_left));
   for temp1 := 1 to 43 do write (chr(horizontal_bar));
   writeln (chr(upper_right));
   writeln (' ':17,chr(vertical_bar),' ':43,chr(vertical_bar));
   write (' ':17,chr(vertical_bar),' ':11,'QUARTERS VERSION 3.2');
   writeln (' ':12,chr(vertical_bar));
   write (' ':17,chr(vertical_bar),' ':5,'Copyright (C) 1987 by Greg Bailey');
   writeln (' ':5,chr(vertical_bar));
   write (' ':17,chr(vertical_bar),' ':15,'July 23, 1987');
   writeln (' ':15,chr(vertical_bar));
   writeln (' ':17,chr(vertical_bar),' ':43,chr(vertical_bar));
   write (' ':17,chr(lower_left));
   for temp1 := 1 to 43 do write (chr(horizontal_bar));
   writeln (chr(lower_right));
   randomize;
   end_game := false;
   level := preset_level;
   for temp1 := 1 to 4 do human_last_move[temp1] := 0;
   for temp1 := 1 to 4 do computer_last_move[temp1] := 0;
   for temp1 := 1 to 7 do
      for temp2 := 1 to 7 do
         board [temp1,temp2] := 0;
   board [2,2] := value_head_dime;
   board [2,6] := value_tail_dime;
   board [3,1] := value_head_nickel;
   board [3,3] := value_head_penny;
   board [3,5] := value_tail_penny;
   board [3,7] := value_tail_nickel;
   board [4,2] := value_head_quarter;
   board [4,6] := value_tail_quarter;
   board [5,1] := value_head_nickel;
   board [5,3] := value_head_penny;
   board [5,5] := value_tail_penny;
   board [5,7] := value_tail_nickel;
   board [6,2] := value_head_dime;
   board [6,6] := value_tail_dime;
   for temp1 := -32767 to 32767 do begin end;
   clrscr;
   gotoxy (1,1);
   for temp1 := 1 to 78 do write (chr(horizontal_bar));
   gotoxy (49,3);
   for temp1 := 49 to 78 do write (chr(horizontal_bar));
   gotoxy (49,5);
   for temp1 := 49 to 78 do write (chr(horizontal_bar));
   gotoxy (49,7);
   for temp1 := 49 to 78 do write (chr(horizontal_bar));
   gotoxy (49,9);
   for temp1 := 49 to 78 do write (chr(horizontal_bar));
   gotoxy (49,11);
   for temp1 := 49 to 78 do write (chr(horizontal_bar));
   gotoxy (1,25);
   for temp1 := 1 to 78 do write (chr(horizontal_bar));
   gotoxy (1,1);
   for temp1 := 1 to 25 do
      begin
         gotoxy (1,temp1);
         write (chr(vertical_bar));
      end;
   for temp1 := 1 to 25 do
      begin
         gotoxy (49,temp1);
         write (chr(vertical_bar));
      end;
   for temp1 := 1 to 25 do
      begin
         gotoxy (78,temp1);
         write (chr(vertical_bar));
      end;
   gotoxy (1,1);
   write (chr(upper_left));
   gotoxy (49,1);
   write (chr(bottom_t_bar));
   gotoxy (78,1);
   write (chr(upper_right));
   gotoxy (49,3);
   write (chr(right_t_bar));
   gotoxy (78,3);
   write (chr(left_t_bar));
   gotoxy (49,5);
   write (chr(right_t_bar));
   gotoxy (78,5);
   write (chr(left_t_bar));
   gotoxy (49,7);
   write (chr(right_t_bar));
   gotoxy (78,7);
   write (chr(left_t_bar));
   gotoxy (49,9);
   write (chr(right_t_bar));
   gotoxy (78,9);
   write (chr(left_t_bar));
   gotoxy (49,11);
   write (chr(right_t_bar));
   gotoxy (78,11);
   write (chr(left_t_bar));
   gotoxy (1,25);
   write (chr(lower_left));
   gotoxy (49,25);
   write (chr(top_t_bar));
   gotoxy (78,25);
   write (chr(lower_right));
   gotoxy (54,2);
   write ('QUARTERS VERSION 3.2');
   gotoxy (62,4);
   write ('LEVEL:  X');
   gotoxy (56,6);
   write ('CONSIDERING:  XX-XX');
   gotoxy (53,8);
   write ('YOUR LAST MOVE:  XX-XX');
   gotoxy (55,10);
   write ('MY LAST MOVE:  XX-XX');
   gotoxy (51,12);
   write ('ENTER MOVE OR "/" FOLLOWED');
   gotoxy (51,13);
   write ('BY A COMMAND.');
   gotoxy (51,14);
   for temp1 := 51 to 76 do write ('-');
   gotoxy (51,23);
   for temp1 := 51 to 76 do write ('-');
   temp1 := 3;
   for temp2 := 1 to 4 do
      begin
         draw_outer_row (temp1);
         temp1 := temp1 + 6;
      end;
   temp1 := 6;
   for temp2 := 1 to 3 do
      begin
         draw_inner_row (temp1);
         temp1 := temp1 + 6;
      end;
   temp1 := 10;
   for temp2 := 1 to 6 do
      begin
         gotoxy (temp1,23);
         write (' ');
         temp1 := temp1 + 6;
      end;
   temp1 := 7;
   for temp2 := 1 to 4 do
      begin
         gotoxy (temp1,3);
         write (chr(horizontal_bar));
         gotoxy (temp1,23);
         write (chr(horizontal_bar));
         temp1 := temp1 + 12;
      end;
   temp1 := 4;
   for temp2 := 1 to 4 do
      begin
         gotoxy (5,temp1);
         write (chr(vertical_bar));
         gotoxy (45,temp1);
         write (chr(vertical_bar));
         temp1 := temp1 + 6;
      end;
   temp1 := 7;
   for temp2 := 1 to 7 do
      begin
         gotoxy (temp1,2);
         write (chr(64+temp2));
         gotoxy (temp1,24);
         write (chr(64+temp2));
         temp1 := temp1 + 6;
      end;
   temp1 := 4;
   for temp2 := 1 to 7 do
      begin
         gotoxy (3,temp1);
         write (chr(56-temp2));
         gotoxy (47,temp1);
         write (chr(56-temp2));
         temp1 := temp1 + 3;
      end;
end;

{----------}

procedure draw_screen (board:board_type; level:integer; human_last_move,
   computer_last_move:move_type);

var
   temp1,
   temp2,
   temp3,
   temp4 : integer;

begin
   for temp1 := 1 to 7 do
      for temp2 := 1 to 7 do
         if ((temp1 mod 2)=(temp2 mod 2)) then
            begin
               temp3 := (temp1 * 6)+1;
               temp4 := ((8 - temp2) * 3)+1;
               gotoxy (temp3,temp4);
               case board[temp1,temp2] of
                  0                  : write (' ');
                  value_head_penny   : write ('P');
                  value_head_nickel  : write ('N');
                  value_head_dime    : write ('D');
                  value_head_quarter : write ('Q');
                  value_tail_penny   : write ('p');
                  value_tail_nickel  : write ('n');
                  value_tail_dime    : write ('d');
                  value_tail_quarter : write ('q');
               end; {case statement}
            end;
   gotoxy (70,4);
   write (level);
   gotoxy (70,8);
   write (chr(64+human_last_move[1]),chr(48+human_last_move[2]),'-');
   write (chr(64+human_last_move[3]),chr(48+human_last_move[4]));
   gotoxy (70,10);
   write (chr(64+computer_last_move[1]),chr(48+computer_last_move[2]),'-');
   write (chr(64+computer_last_move[3]),chr(48+computer_last_move[4]));
   for temp1 := 15 to 22 do
      begin
         gotoxy (51,temp1);
         for temp2 := 1 to 26 do write (' ');
      end;
   gotoxy (51,24);
   for temp1 := 1 to 26 do write (' ');
end;

{----------}

procedure get_computer_move (var board:board_type; var end_game:boolean;
   level:integer; var computer_last_move:move_type);

var
   temp1,
   temp_score,
   true_level : integer;

procedure make_move (board:board_type; level:integer; var move:move_type;
   var score:integer; true_level:integer);

var
   stop_flag,
   store_stop_flag : boolean;
   mode,
   score1,
   score2,
   score3,
   x_from,
   y_from,
   x_to,
   y_to,
   store_x_from,
   store_y_from,
   store_x_to,
   store_y_to,
   from_contents_1,
   to_contents_1,
   from_contents_2,
   to_contents_2   : integer;
   temp_move       : move_type;

function sgn (sgnarg : integer) : integer;

begin
   if sgnarg < 0 then sgn := -1;
   if sgnarg = 0 then sgn := 0;
   if sgnarg > 0 then sgn := 1;
end;

procedure move_piece; forward;

procedure checkmove2;

begin
   case mode of
      1 : begin
             if level = true_level
                then
                   begin
                      gotoxy (70,6);
                      write (chr(64+x_from),chr(48+y_from),'-');
                      write (chr(64+x_to),chr(48+y_to));
                   end;
             from_contents_1 := board[x_from,y_from];
             to_contents_1 := board[x_to,y_to];
             board[x_to,y_to] := board[x_from,y_from];
             board[x_from,y_from] := 0;
             store_x_from := x_from;
             store_y_from := y_from;
             store_x_to := x_to;
             store_y_to := y_to;
             store_stop_flag := stop_flag;
             score2 := -999;
             mode := 2;
             for x_from := 1 to 7 do
                for y_from := 1 to 7 do
                   if board[x_from,y_from]>0 then move_piece;
             mode := 1;
             stop_flag := store_stop_flag;
             x_from := store_x_from;
             y_from := store_y_from;
             x_to := store_x_to;
             y_to := store_y_to;
             board[x_from,y_from] := from_contents_1;
             board[x_to,y_to] := to_contents_1;
             if ((score2 < score1) or ((score2 = score1) and (random < 0.2)))
                then
                   begin
                      score1  := score2;
                      score   := score1;
                      move[1] := x_from;
                      move[2] := y_from;
                      move[3] := x_to;
                      move[4] := y_to;
                   end;
          end;
      2 : if level = 1
             then
                begin
                   score3 := -to_contents_1-board[x_to,y_to];
                   if score3 > score2 then score2 := score3;
                end
             else
                begin
                   from_contents_2 := board[x_from,y_from];
                   to_contents_2 := board[x_to,y_to];
                   board[x_to,y_to] := board[x_from,y_from];
                   board[x_from,y_from] := 0;
                   if to_contents_2 = value_tail_quarter
                      then
                         score3 := 9999
                      else
                         make_move
                            (board,(level-1),temp_move,score3,true_level);
                   board[x_from,y_from] := from_contents_2;
                   board[x_to,y_to] := to_contents_2;
                   score3 := score3 -to_contents_1-board[x_to,y_to];
                   if score3 > score2 then score2 := score3;
                end;
   end; {case statement}
end;

procedure checkmove;

begin
   stop_flag:=false;
   if (x_to<1) or (x_to>7) or (y_to<1) or (y_to>7)
      then
         stop_flag:=true
      else
         if sgn(board[x_from,y_from])=sgn(board[x_to,y_to])
            then
               stop_flag:=true
            else
               if sgn(board[x_from,y_from])=-sgn(board[x_to,y_to])
                  then
                     begin
                        stop_flag:=true;
                        checkmove2;
                     end
                  else
                     checkmove2;
end;

procedure move_piece;

begin
   case board[x_from,y_from] of
      value_head_penny,
      value_tail_penny,
      value_head_quarter,
      value_tail_quarter : begin
                              x_to:=x_from-1;
                              y_to:=y_from-1;
                              checkmove;
                              y_to:=y_from+1;
                              checkmove;
                              x_to:=x_from+1;
                              y_to:=y_from-1;
                              checkmove;
                              y_to:=y_from+1;
                              checkmove;
                              if x_from mod 2=1 then
                                 begin
                                    x_to:=x_from;
                                    y_to:=y_from-2;
                                    checkmove;
                                    y_to:=y_from+2;
                                    checkmove;
                                    y_to:=y_from;
                                    x_to:=x_from-2;
                                    checkmove;
                                    x_to:=x_from+2;
                                    checkmove;
                                 end;
                           end;
      value_head_nickel,
      value_tail_nickel  : begin
                              stop_flag:=false;
                              x_to:=x_from;
                              y_to:=y_from;
                              while not stop_flag do
                                 begin
                                    y_to:=y_to-2;
                                    checkmove;
                                 end;
                              stop_flag:=false;
                              x_to:=x_from;
                              y_to:=y_from;
                              while not stop_flag do
                                 begin
                                    y_to:=y_to+2;
                                    checkmove;
                                 end;
                              stop_flag:=false;
                              x_to:=x_from;
                              y_to:=y_from;
                              while not stop_flag do
                                 begin
                                    x_to:=x_to-2;
                                    checkmove;
                                 end;
                              stop_flag:=false;
                              x_to:=x_from;
                              y_to:=y_from;
                              while not stop_flag do
                                 begin
                                    x_to:=x_to+2;
                                    checkmove;
                                 end;
                           end;
      value_head_dime,
      value_tail_dime    : begin
                              stop_flag:=false;
                              x_to:=x_from;
                              y_to:=y_from;
                              while not stop_flag do
                                 begin
                                    x_to:=x_to-1;
                                    y_to:=y_to-1;
                                    checkmove;
                                 end;
                              stop_flag:=false;
                              x_to:=x_from;
                              y_to:=y_from;
                              while not stop_flag do
                                 begin
                                    x_to:=x_to-1;
                                    y_to:=y_to+1;
                                    checkmove;
                                 end;
                              stop_flag:=false;
                              x_to:=x_from;
                              y_to:=y_from;
                              while not stop_flag do
                                 begin
                                    x_to:=x_to+1;
                                    y_to:=y_to-1;
                                    checkmove;
                                 end;
                              stop_flag:=false;
                              x_to:=x_from;
                              y_to:=y_from;
                              while not stop_flag do
                                 begin
                                    x_to:=x_to+1;
                                    y_to:=y_to+1;
                                    checkmove;
                                 end;
                           end;
   end; {case statement}
end;

begin
   score1 := 999;
   mode := 1;
   for x_from := 1 to 7 do
      for y_from := 1 to 7 do
         if board[x_from,y_from]<0 then move_piece;
end;

begin
   true_level := level;
   gotoxy (51,24);
   write ('THINKING...');
   for temp1 := 1 to 14 do write (' ');
   make_move (board,level,computer_last_move,temp_score,true_level);
   end_game := (board[computer_last_move[3],computer_last_move[4]])=
      (value_head_quarter);
   board[computer_last_move[3],computer_last_move[4]] :=
      board[computer_last_move[1],computer_last_move[2]];
   board[computer_last_move[1],computer_last_move[2]] := 0;
end;

{----------}

procedure get_human_move (var board:board_type; var end_game:boolean;
   var level:integer; var human_last_move,computer_last_move:move_type);

var
   ok    : boolean;
   temp1 : char;
   temp2 : integer;

procedure get_letter (var letter:char);

begin
   read (kbd,letter);
   while not (letter in ['A'..'G','a'..'g','/']) do
      read (kbd,letter);
   if not (letter in ['A'..'G','/'])
      then letter := chr(ord(letter)-32);
end;

procedure get_number (var number:char);

begin
   read (kbd,number);
   while not (number in ['1'..'7']) do
      read (kbd,number);
end;

procedure command (var board:board_type; var end_game:boolean;
   var level:integer; var human_last_move,computer_last_move:move_type);

var
   temp1,
   temp2      : integer;
   temp3,
   temp4      : char;
   temp_board : board_type;
   temp_move  : move_type;
   temp_game  : boolean;

begin
   gotoxy (51,15);
   write ('C = CLEAR THE BOARD');
   gotoxy (51,16);
   write ('E = EDIT THE BOARD');
   gotoxy (51,17);
   write ('H = HINT');
   gotoxy (51,18);
   write ('L = CHANGE LEVEL');
   gotoxy (51,19);
   write ('R = RESTART GAME');
   gotoxy (51,20);
   write ('S = SWAP SIDES');
   gotoxy (51,22);
   write ('X = EXIT THIS MENU');
   gotoxy (51,24);
   write ('COMMAND:');
   for temp1 := 1 to 18 do write (' ');
   gotoxy (61,24);
   read (kbd,temp3);
   while not (temp3 in
      ['c','C','e','E','h','H','l','L','r','R','s','S','x','X'])
      do read (kbd,temp3);
   write (temp3);
   case temp3 of
      'c','C' : begin
                   for temp1 := 1 to 7 do
                      for temp2 := 1 to 7 do
                         board[temp1,temp2] := 0;
                end;
      'e','E' : begin
                   gotoxy (51,24);
                   write ('EDIT:');
                   for temp1 := 1 to 21 do write (' ');
                   gotoxy (58,24);
                   get_letter (temp4);
                   while temp4 = '/' do
                      get_letter (temp4);
                   write (temp4);
                   temp1 := ord (temp4)-64;
                   get_number (temp4);
                   write (temp4);
                   temp2 := ord (temp4)-48;
                   if (temp1 mod 2)=(temp2 mod 2)
                      then
                         begin
                            write (' = ');
                            read (kbd,temp4);
                            while not (temp4 in
                               ['p','n','d','q','P','N','D','Q',' '])
                               do read (kbd,temp4);
                            write (temp4);
                            case temp4 of
                               'p' : board[temp1,temp2] := value_tail_penny;
                               'n' : board[temp1,temp2] := value_tail_nickel;
                               'd' : board[temp1,temp2] := value_tail_dime;
                               'q' : board[temp1,temp2] := value_tail_quarter;
                               'P' : board[temp1,temp2] := value_head_penny;
                               'N' : board[temp1,temp2] := value_head_nickel;
                               'D' : board[temp1,temp2] := value_head_dime;
                               'Q' : board[temp1,temp2] := value_head_quarter;
                               ' ' : board[temp1,temp2] := 0;
                            end; {case statement}
                         end;
                end;
      'h','H' : begin
                   temp_board := board;
                   for temp1 := 1 to 7 do
                      for temp2 := 1 to 7 do
                         case board[temp1,temp2] of
                            0                  : begin end;
                            value_head_penny   : board[temp1,temp2] :=
                                                  value_tail_penny;
                            value_head_nickel  : board[temp1,temp2] :=
                                                   value_tail_nickel;
                            value_head_dime    : board[temp1,temp2] :=
                                                    value_tail_dime;
                            value_head_quarter : board[temp1,temp2] :=
                                                    value_tail_quarter;
                            value_tail_penny   : board[temp1,temp2] :=
                                                    value_head_penny;
                            value_tail_nickel  : board[temp1,temp2] :=
                                                    value_head_nickel;
                            value_tail_dime    : board[temp1,temp2] :=
                                                    value_head_dime;
                            value_tail_quarter : board[temp1,temp2] :=
                                                    value_head_quarter;
                         end; {case statement}
                   get_computer_move (board,temp_game,level,temp_move);
                   gotoxy (51,24);
                   write ('HINT:');
                   for temp1 := 1 to 21 do write (' ');
                   gotoxy (58,24);
                   write (chr(64+temp_move[1]),chr(48+temp_move[2]),'-');
                   write (chr(64+temp_move[3]),chr(48+temp_move[4]));
                   for temp1 := 1 to 8 do write (' ');
                   write ('<KEY>');
                   read (kbd,temp4);
                   board := temp_board;
                end;
      'l','L' : begin
                   gotoxy (51,24);
                   write ('LEVEL:');
                   for temp1 := 1 to 20 do write (' ');
                   gotoxy (59,24);
                   read (kbd,temp4);
                   while not (temp4 in ['1'..'5']) do
                      read (kbd,temp4);
                   write (temp4);
                   level := ord(temp4)-48;
                end;
      'r','R' : initialize (board,end_game,level,human_last_move,
                   computer_last_move);
      's','S' : begin
                   for temp1 := 1 to 7 do
                      for temp2 := 1 to 7 do
                         case board[temp1,temp2] of
                            0                  : begin end;
                            value_head_penny   : board[temp1,temp2] :=
                                                  value_tail_penny;
                            value_head_nickel  : board[temp1,temp2] :=
                                                   value_tail_nickel;
                            value_head_dime    : board[temp1,temp2] :=
                                                    value_tail_dime;
                            value_head_quarter : board[temp1,temp2] :=
                                                    value_tail_quarter;
                            value_tail_penny   : board[temp1,temp2] :=
                                                    value_head_penny;
                            value_tail_nickel  : board[temp1,temp2] :=
                                                    value_head_nickel;
                            value_tail_dime    : board[temp1,temp2] :=
                                                    value_head_dime;
                            value_tail_quarter : board[temp1,temp2] :=
                                                    value_head_quarter;
                         end; {case statement}
                end;
      'x','X' : begin end;
   end; {case statement}
   draw_screen (board,level,human_last_move,computer_last_move);
end;

begin
   repeat
      gotoxy (51,24);
      write ('YOUR MOVE:');
      for temp2 := 1 to 16 do write (' ');
      gotoxy (63,24);
      get_letter (temp1);
      while temp1 = '/' do
         begin
            command (board,end_game,level,human_last_move,computer_last_move);
            gotoxy (51,24);
            write ('YOUR MOVE:');
            for temp2 := 1 to 16 do write (' ');
            gotoxy (63,24);
            get_letter (temp1);
         end;
      write (temp1);
      human_last_move[1] := ord(temp1)-64;
      get_number (temp1);
      write (temp1);
      human_last_move[2] := ord(temp1)-48;
      write ('-');
      get_letter (temp1);
      write (temp1);
      human_last_move[3] := ord(temp1)-64;
      get_number (temp1);
      write (temp1);
      human_last_move[4] := ord(temp1)-48;
      ok := true;
      if not ((human_last_move[1] mod 2)=(human_last_move[2] mod 2))
         then ok := false;
      if not ((human_last_move[3] mod 2)=(human_last_move[4] mod 2))
         then ok := false;
      if not (board[human_last_move[1],human_last_move[2]]>0)
         then ok := false;
      if not (board[human_last_move[3],human_last_move[4]]<=0)
         then ok := false;
      if not ok
         then
            begin
               gotoxy (63,24);
               write ('ILLEGAL MOVE');
               for temp2 := -32767 to 32767 do begin end;
            end;
   until ok;
   end_game :=
      (board[human_last_move[3],human_last_move[4]])=(value_tail_quarter);
   board[human_last_move[3],human_last_move[4]] :=
      board[human_last_move[1],human_last_move[2]];
   board[human_last_move[1],human_last_move[2]] := 0;
end;

{----------}

procedure human_wins;

var
   temp1 : char;

begin
   gotoxy (51,17);
   write ('CONGRATULATIONS!');
   gotoxy (51,18);
   write ('YOU HAVE WON THE GAME!');
   gotoxy (51,20);
   write ('Press any key to exit.');
   gotoxy (51,24);
   read (kbd,temp1);
   clrscr;
end;

{----------}

procedure computer_wins;

var
   temp1 : char;

begin
   gotoxy (51,17);
   write ('SORRY!');
   gotoxy (51,18);
   write ('I HAVE WON THE GAME!');
   gotoxy (51,20);
   write ('Press any key to exit.');
   gotoxy (51,24);
   read (kbd,temp1);
   clrscr;
end;

{----------}

begin
   initialize
      (board,end_game,level,human_last_move,computer_last_move);
   draw_screen
      (board,level,human_last_move,computer_last_move);
   while not end_game do
      begin
         get_human_move
            (board,end_game,level,human_last_move,computer_last_move);
         draw_screen
            (board,level,human_last_move,computer_last_move);
         if end_game
            then
               human_wins
            else
               begin
                  get_computer_move
                     (board,end_game,level,computer_last_move);
                  draw_screen
                     (board,level,human_last_move,computer_last_move);
                  if end_game then computer_wins;
               end;
      end;
end.
